हैश जनरेटर: MD5, SHA-1 और SHA-256

कोई टेक्स्ट लिखें, और हेक्साडेसिमल में उसके MD5, SHA-1, SHA-256, SHA-384 और SHA-512 डाइजेस्ट देखें। कुंजी जोड़ें तो हर पंक्ति एक HMAC बन जाती है, यानी गुप्त कुंजी से बना हस्ताक्षर।

मुफ्त आपके ब्राउज़र में चलता है जाँचा गया मंगलवार, 10 नवंबर 2026

हैश करने वाला टेक्स्ट, UTF-8 बाइट के रूप में। हिंदी का हर अक्षर तीन बाइट लेता है, और é या ü जैसे अक्षर दो बाइट।

सादे डाइजेस्ट के लिए खाली छोड़ें। कुंजी हो तो हर पंक्ति इसी कुंजी से बना HMAC होती है।

परिणाम

डाइजेस्ट

यह टूल आपके ब्राउज़र में चलता है। आप जो लिखते हैं, वह हमें नहीं भेजा जाता।

इसका इस्तेमाल कैसे करें

  1. टेक्स्ट में टेक्स्ट लिखें या चिपकाएँ।
  2. सादे डाइजेस्ट के लिए कुंजी (वैकल्पिक) खाली छोड़ें, या HMAC पाने के लिए कुंजी लिखें।
  3. किसी पंक्ति से डाइजेस्ट कॉपी करें, या पूरी तालिका रखने के लिए CSV के रूप में डाउनलोड करें दबाएँ।
  4. पहले कॉलम के एल्गोरिदम को उस एल्गोरिदम से मिलाएँ जो आपका सिस्टम या दस्तावेज माँगता है।

हैश क्या है

हैश फ़ंक्शन किसी भी टेक्स्ट को एक तय लंबाई के कोड में बदलता है, जिसे डाइजेस्ट कहते हैं। एक ही टेक्स्ट हमेशा एक ही डाइजेस्ट देता है, थोड़े से बदलाव से पूरी तरह अलग डाइजेस्ट बनता है, और डाइजेस्ट से टेक्स्ट वापस नहीं निकाला जा सकता। यहाँ डाइजेस्ट हेक्साडेसिमल में लिखे गए हैं: MD5 में 32 अंक होते हैं, SHA-1 में 40, SHA-256 में 64, SHA-384 में 96 और SHA-512 में 128।

हेक्साडेसिमल अंक = बिट ÷ 4

MD5      128 ÷ 4 = 32
SHA-256  256 ÷ 4 = 64
SHA-512  512 ÷ 4 = 128

कौन सा एल्गोरिदम लें

MD5 और SHA-1 टूटे हुए हैं। दो अलग टेक्स्ट का एक जैसा डाइजेस्ट खोजा जा सकता है, इसलिए इन्हें हस्ताक्षर या प्रमाणपत्र के लिए इस्तेमाल नहीं करना चाहिए। ये पुराने सिस्टम में अब भी दिखते हैं, और डाउनलोड में गलती से हुई खराबी की जल्दी जाँच के लिए काम आते हैं। SHA-256 और SHA-512 मौजूदा मानक FIPS 180-4 के हिस्से हैं, और यही आम चुनाव हैं।

पासवर्ड स्टोर करने के लिए Argon2 या bcrypt जैसा पासवर्ड हैशिंग फ़ंक्शन लें। इस पेज का कोई भी डाइजेस्ट इसके लिए नहीं बना है।

HMAC: कुंजी वाला डाइजेस्ट

HMAC (RFC 2104) एक कुंजी को हैश के साथ तय तरीके से जोड़ता है। वही HMAC सिर्फ वही व्यक्ति बना सकता है जो कुंजी जानता हो, इसलिए यह दिखाता है कि संदेश किसी ज्ञात भेजने वाले से आया है और रास्ते में बदला नहीं गया। पेज HMAC उन्हीं एल्गोरिदम से निकालता है जिनसे सादे डाइजेस्ट निकलते हैं।

टेक्स्ट यानी बाइट

  • टेक्स्ट UTF-8 बाइट के रूप में हैश होता है (RFC 3629)। ASCII अक्षर एक बाइट लेते हैं, é या ü जैसे अक्षर दो, हिंदी का हर अक्षर तीन, और इमोजी चार।
  • लाइन का अलग अंत, अलग एन्कोडिंग या एक अतिरिक्त स्पेस अलग डाइजेस्ट देता है, इसलिए वही बाइट हैश करें जो दूसरा टूल करता है।

उदाहरण: abc और एक HMAC

टेक्स्ट abc के डाइजेस्ट प्रकाशित मान हैं: MD5 के लिए RFC 1321 में, और SHA-1, SHA-256, SHA-384 और SHA-512 के लिए FIPS 180-4 में।

कुंजी Jefe और टेक्स्ट what do ya want for nothing? के साथ HMAC-SHA-256 है 5bdcc146bf60754e6a042426089575c75a003f089d2739839dec58b964ec3843, जो RFC 4231 के परीक्षण 2 का परीक्षण मान है।

एल्गोरिदम abc का डाइजेस्ट
MD5 900150983cd24fb0d6963f7d28e17f72
SHA-1 a9993e364706816aba3e25717850c26c9cd0d89d
SHA-256 ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad
SHA-384 cb00753f45a35e8bb5a03d699ac65007272c32ab0eded1631a8b605a43ff5bed8086072ba1e7cc2358baeca134c825a7
SHA-512 ddaf35a193617abacc417349ae20413112e6fa4e89a97ea20a9eeee64b55d39a2192992a274fc1a836ba3c23a3feebbd454d4423643ce80e2a9ac94fa54ca49f

अक्सर पूछे जाने वाले सवाल

क्या पासवर्ड के लिए MD5 सुरक्षित है?

नहीं। MD5 तेज है और टूटा हुआ है, इसलिए MD5 पासवर्ड हैश की लीक हुई सूची आसानी से तोड़ी जा सकती है। पासवर्ड Argon2 या bcrypt जैसे पासवर्ड हैशिंग फ़ंक्शन से स्टोर करें।

क्या SHA-256 एन्क्रिप्शन जैसा ही है?

नहीं। हैश एक तरफा है: उसे वापस टेक्स्ट में नहीं बदला जा सकता, और उसमें कोई कुंजी नहीं होती। एन्क्रिप्शन सही कुंजी से उलटा जा सकता है। डेटा की अखंडता जाँचने के लिए हैश लें, और यह जाँचने के लिए कि संदेश कुंजी जानने वाले ने भेजा है, HMAC।

हैश और HMAC में क्या फर्क है?

हैश सिर्फ टेक्स्ट पर निर्भर करता है। HMAC के लिए गुप्त कुंजी भी चाहिए, इसलिए उसे सिर्फ कुंजी वाला व्यक्ति बना या जाँच सकता है। वेबहुक और API के हस्ताक्षर आम तौर पर HMAC-SHA-256 होते हैं।

मेरे डाइजेस्ट दूसरे टूल से अलग क्यों हैं?

बाइट एक जैसे होने चाहिए। अलग लाइन-अंत, Windows-1254 जैसी अलग एन्कोडिंग, या एक अतिरिक्त स्पेस हर डाइजेस्ट बदल देता है। वही बाइट हैश करें जो दूसरा टूल हैश करता है।

क्या मेरा टेक्स्ट कहीं भेजा जाता है?

नहीं। डाइजेस्ट आपके ब्राउज़र में निकाले जाते हैं, और टेक्स्ट न अपलोड होता है, न सहेजा जाता है।

क्या इस टूल से कोई फ़ाइल जाँची जा सकती है?

यह पेज सिर्फ टेक्स्ट हैश करता है। फ़ाइल के लिए अपने ऑपरेटिंग सिस्टम का चेकसम टूल लें, या डाउनलोड साइट का प्रकाशित चेकसम।

स्रोत

आँकड़े और टेक्स्ट आखिरी बार मंगलवार, 10 नवंबर 2026 को जाँचे गए।

साइट चलाने के लिए हम जरूरी कुकीज़ इस्तेमाल करते हैं। आपकी सहमति से Google विज्ञापन कुकीज़ भी इस्तेमाल करता है, ताकि व्यक्तिगत विज्ञापन दिखें। अगर आप उन्हें अस्वीकार करते हैं, तो भी आपको विज्ञापन दिखेंगे, पर वे व्यक्तिगत नहीं होंगे।